=== modified file 'src/com/goldencode/p2j/uast/ClassDefinition.java'
--- old/src/com/goldencode/p2j/uast/ClassDefinition.java	2022-05-16 16:24:45 +0000
+++ new/src/com/goldencode/p2j/uast/ClassDefinition.java	2022-05-23 20:10:15 +0000
@@ -2718,39 +2904,6 @@
    }
    
    /**
-    * Generate a text descriptor of the method signature that includes the mode and type of
-    * each parameter.  Multiple parameters are comma separated and the entire string will have
-    * the method name and the parameters will be inside open and close parenthesis.
-    *
-    * @param    name
-    *           Method name.
-    * @param    sig
-    *           The method signature.
-    *
-    * @return   The signature descriptor.
-    */
-   private String renderSignature(String name, ParameterKey[] sig)
-   {
-      if (sig == null)
-         sig = new ParameterKey[0];
-      
-      StringBuilder sb = new StringBuilder();
-      sb.append(name.toLowerCase()).append("(");
-      
-      for (int i = 0; i < sig.length; i++)
-      {
-         if (i > 0)
-         {
-            sb.append(", ");
-         }
-         
-         sb.append(sig[i].toString());
-      }
-      
-      return sb.append(")").toString();
-   }
-   
-   /**
     * Process a method call to mark any "fuzzy" parameters with the wrapper type that must
     * be used for the actual call.
     * 
@@ -2758,8 +2911,15 @@
     *           The OO_METH_* node whose parameters will be annotated.
     * @param    callSig
     *           The array of parameter types that is the method definition signature.
+    * @param    defSig
+    *           The array of parameter types that is the method definition signature.
+    * @param    overrides
+    *           Type overrides found by any fuzzy matching for this method.
     */
-   private void annotateCallSignature(Aast call, ParameterKey[] callSig, ParameterKey[] defSig)
+   private void annotateCallSignature(Aast           call,
+                                      ParameterKey[] callSig,
+                                      ParameterKey[] defSig,
+                                      String[]       overrides)
    {
       int idx = 0;
       
@@ -2786,6 +2946,8 @@
              type != KW_BY_REF  &&
              type != KW_BY_VALUE)
          {
+            parm.putAnnotation("jtype", defSig[idx].toJava());
+            
             parm.putAnnotation("parmtype", defSig[idx].mode.longValue());
             if (parm.getType() == PARAMETER)
             {
@@ -2796,9 +2958,18 @@
             boolean outputMode = defSig[idx].mode != null && defSig[idx].mode.intValue() != KW_INPUT;
 
             String classname = defSig[idx].type;
-            String callType = callSig[idx] == null ? null : callSig[idx].type;
+            String callType = callSig[idx].type;
             String defType = defSig[idx].type;
             
+            int idx1 = defType.indexOf("[");
+            int idx2 = callType.indexOf("[");
+            
+            // remove the [] from the classname/callType
+            if (idx1 > 0)
+            {
+               classname = defType.substring(0, idx1);
+            }
+            
             if (outputMode)
             {
                if (!callSig[idx].isExtent())
@@ -2821,61 +2992,20 @@
                      }
                   }
                }
-
-               if ("integer".equals(classname) || 
-                   "int64".equals(classname)   || 
-                   "character".equals(classname))
-               {
-                  // for OUTPUT and INPUT-OUTPUT variables, we need to force the classname in
-                  // certain cases
-                  if (!defType.equals(callType))
-                  {
-                     parm.putAnnotation("classname", classname);
-                  }
-               }
             }
-            else if (!defType.equals(callType))
+            
+            if (!defType.equals(callType))
             {
                // force everything for now
                boolean force = true;
 
-               // unknown value or BDT (POLY cases) match anything
-               //if (callType == null                ||
-               //    "BaseDataType".equals(callType) ||
-               //    "unknown".equals(callType))
-               //{
-               //   force = true;
-               //}
-               //// narrowing matches are OK, widening are NOT OK 
-               //else if ("int64".equals(defType) && "integer".equals(callType))
-               //{
-               //   force = true;
-               //}
-               //else if ("decimal".equals(defType) &&
-               //         ("integer".equals(callType) || "int64".equals(callType)))
-               //{
-               //   force = true;
-               //}
-               //else if ("longchar".equals(defType) &&
-               //         "character".equals(callType))
-               //{
-               //   force = true;
-               //}
-               //else if ("datetime".equals(defType) && "date".equals(callType))
-               //{
-               //   force = true;
-               //}
-               //else if ("datetimetz".equals(defType) &&
-               //         ("date".equals(callType) || "datetime".equals(callType)))
-               //{
-               //   force = true;
-               //}
-               
-               if (classname.startsWith("BUFFER ")  || 
-                   classname.equals("TEMP-TABLE")   ||
-                   classname.equals("TABLE-HANDLE") ||
-                   classname.equals("DATASET")      ||
-                   classname.equals("DATASET-HANDLE"))
+               if (classname.startsWith("BUFFER ")       || 
+                   classname.startsWith("TEMP-TABLE")    ||
+                   classname.equals("TABLE-HANDLE")      ||
+                   classname.startsWith("DATASET ")      ||
+                   classname.equals("DATASET-HANDLE")    ||
+                   classname.startsWith("object<")       ||
+                   classname.startsWith("jobject<"))
                {
                   force = false;
                }
@@ -2883,14 +3013,13 @@
                {
                   // non-extents and extents are matched here
 
-                  int idx1 = defType.indexOf("[");
-                  int idx2 = callType.indexOf("[");
-                  
+                  // both caller and def are extent
                   if (idx1 != -1 && idx2 != -1)
                   {
                      String prefix1 = defType.substring(0, idx1);
                      String prefix2 = callType.substring(0, idx2);
                      
+                     // compare data types
                      if (prefix1.equals(prefix2))
                      {
                         // extent differences alone don't need wrapping
@@ -2907,6 +3036,7 @@
                                           call.dumpTree());
                      }
                   }
+                  // the caller is extent or the def is extent but not both
                   else if (idx1 != -1 || idx2 != -1)
                   {
                      // TODO: conversion needs to be enhanced to support wrapping array parms
@@ -2917,13 +3047,7 @@
                                        callSig[idx],
                                        call.dumpTree());
                   }
-                  else if (parm.getType() == UNKNOWN_VAL)
-                  {
-                     if (classname.startsWith("object"))
-                     {
-                        classname = "object";
-                     }
-                  }
+                  // neither caller nor def are extent
                   else if (parm.getType() == FUNC_CLASS    || 
                            parm.getType() == VAR_CLASS     ||
                            parm.getType() == FIELD_CLASS   ||
@@ -2935,51 +3059,41 @@
                      force = false;
                   }
                }
-               
-               if (force && 
-                   !(parm.getIndexPos() == 3                                     && 
+
+               // do not wrap the last parameter for Progress.Lang.Class:setParameter
+               if (!(parm.getIndexPos() == 3                                     && 
                      parm.getParent().getType() == OO_METH_LOGICAL               && 
                      parm.getParent().getText().equalsIgnoreCase("setParameter") &&
                      parm.getParent().getAnnotation("found-in-cls")
                                      .toString()
                                      .equalsIgnoreCase("Progress.Lang.ParameterList")))
                {
-                  if (classname.startsWith("object<"))
-                  {
-                     classname = "object";
-                     force = false;
-                  }
-                  else if (classname.startsWith("jobject<"))
-                  {
-                     force = false;
-                     classname = "jobject";
-                  }
+                  if (force)
+                  {
+                     if (callType.indexOf('[') < 0)
+                     {
+                        if (parm.getType() == UNKNOWN_VAL || 
+                            (parm.getType() == PARAMETER && parm.getFirstChild().getType() == UNKNOWN_VAL))
+                        {
+                           if (parm.getType() == PARAMETER)
+                           {
+                              parm.putAnnotation("wrap_parameter", true);
+                           }
+                        }
+                        else if (!classname.equals("BaseDataType") &&
+                                 !classname.equals("Object"))
+                        {
+                           parm.putAnnotation("wrap_parameter", true);
+                        }
+                     }
 
-                  // do not wrap the last parameter for Progress.Lang.Class:setParameter
-                  
-                  // parm.putAnnotation("wrap", new Boolean(true));
-                  // parm.putAnnotation("chp_wrapper", classname);
-                  if (force && callType.indexOf('[') < 0)
-                  {
-                     if (parm.getType() == UNKNOWN_VAL || 
-                         (parm.getType() == PARAMETER && 
-                          parm.getFirstChild().getType() == UNKNOWN_VAL))
-                     {
-                        if (parm.getType() == PARAMETER)
-                        {
-                           parm.putAnnotation("wrap_parameter", new Boolean(true));
-                        }
-                     }
-                     else if ((!nowrapObjects || !classname.startsWith("object<")) && 
-                              !classname.startsWith("jobject<") && 
-                              !classname.equals("BaseDataType") &&
-                              !classname.equals("Object"))
-                     {
-                        // TODO: CA: what's the reason for nowrapObjects?
-                        parm.putAnnotation("wrap_parameter", Boolean.TRUE);
-                     }
+                     if (idx2 > 0)
+                     {
+                        callType = callType.substring(0, idx2);
+                     }                     
                      
                      parm.putAnnotation("classname", classname);
+                     parm.putAnnotation("calltype", callType);
                   }
                }
             }
@@ -3062,7 +3176,6 @@
             {
                Iterator<MemberData> iter = defs.values().iterator();
                
-               outer:
                while (iter.hasNext())
                {
                   MemberData dat = checkAccessRights(iter.next(), access);
@@ -3131,47 +3244,56 @@
     * @return   Member data or <code>null</code> if no such variable or data
     *           member exists. 
     */
-   private MemberData lookupMethodWorker(String         name,
-                                         ParameterKey[] sig,
-                                         int            access,
-                                         boolean        isStatic,
-                                         boolean        internal,
-                                         Aast           node)
+   private MethodSearchResult lookupMethodWorker(String         name,
+                                                 ParameterKey[] sig,
+                                                 int            access,
+                                                 boolean        isStatic,
+                                                 boolean        internal,
+                                                 Aast           node)
    {
-      MemberData mdat = null;
+      MethodSearchResult result = null;
       
       synchronized (lock)
       {
-         mdat = exactMethodLookup(name, sig, access, isStatic, internal);
+         result = exactMethodLookup(name, sig, access, isStatic, internal);
 
-         if (mdat == null && !isStatic && internal)
+         if (result == null && !isStatic && internal)
          {
             // can't find an instance member, check for static
-            mdat = exactMethodLookup(name, sig, access, true, internal);
+            result = exactMethodLookup(name, sig, access, true, internal);
          }
          
-         if (mdat == null)
+         if (result == null)
          {
-            mdat = fuzzyMethodLookup(name, sig, access, isStatic, internal, node);
+            result = fuzzyMethodLookup(name, sig, access, isStatic, internal, node);
    
-            if (mdat == null && !isStatic && internal)
+            if (result == null && !isStatic && internal)
             {
                // can't find an instance member, check for static
-               mdat = fuzzyMethodLookup(name, sig, access, true, internal, node);
+               result = fuzzyMethodLookup(name, sig, access, true, internal, node);
             }
          }
       }
       
-      return mdat;
+      return result;
    }
    
    /**
-    * Find the named method based on an exact signature match. This method will search up the
-    * parent hierarchy (recursively) if no exact match is found in the current class.
+    * Find the named method based on an exact signature match. This method searches all methods in the
+    * parent hierarchy not just in the current class.  This search the hierarchy approach is needed so
+    * that some special exceptions can be honored:
+    * <p>
+    * <ul>
+    *    <li>If the caller does not specify a mode and there is an otherwise exact match, that method is
+    *        selected.  Buffers have no mode processing so this case is ignored for them.</li>
+    *    <li>A caller's table-handle or dataset-handle parameter which has an exact match is disallowed
+    *        if there are any alternatives with a table/dataset at that parameter AND that parameter type
+    *        is what determines that the signatures are different.</li>
+    * </ul>
     *
     * @param    name
     *           Resource name.
-    * @param    sig
+    * @param    caller
     *           Method call signature.
     * @param    access
     *           Access mode (<code>KW_PUBLIC</code>, <code>KW_PROTECTD</code> or
@@ -3184,62 +3306,220 @@
     *
     * @return   Resource found or <code>null</code> if no match exists.
     */
-   private MemberData exactMethodLookup(String         name,
-                                        ParameterKey[] sig,
-                                        int            access,
-                                        boolean        isStatic,
-                                        boolean        internal)
-   {
-      MemberData mdat = null;
-      
-      synchronized (lock)
-      {
-         Map<String, Map<SignatureKey, MemberData>> map = isStatic ? smethods : imethods;
-         
-         if (map != null)
-         {
-            Map<SignatureKey, MemberData> defs = map.get(name.toLowerCase());
-            
-            if (defs != null)
-            {
-               // exact signature match is based on the key lookup
-               mdat = checkAccessRights(defs.get(new SignatureKey(sig)), access);
-            }
-         }
-         
-         // ignore if the static/instance does not match
-         if (mdat != null && !((!isStatic && (!mdat.isStatic || internal)) ||
-                               (isStatic && mdat.isStatic)))
-         {
-            // clear our result
-            mdat = null;
-         }
-         
-         // only look up the parent hierarchy if we haven't got a match yet; static lookups only
-         // work for internal usage, non-static lookups always work
-         if (mdat == null && parents != null)
-         {
-            // change access mode since we aren't allowed to see private stuff in parent
-            int _access = (access == KW_PRIVATE) ? KW_PROTECTD : access;
-            
-            for (ClassDefinition parent : parents)
-            {
-               if (parent == null)
-               {
-                  String theSig = Arrays.toString(sig);
-                  throw new NullPointerException("Null parent found for " + name + " " + theSig);
-               }
-               
-               // recurse up inheritence hierarchy
-               mdat = parent.exactMethodLookup(name, sig, _access, isStatic, internal);
-               
-               if (mdat != null)
-                  break;
-            }
-         }
-      }
-      
-      return mdat;
+   private MethodSearchResult exactMethodLookup(final String         name,
+                                                final ParameterKey[] caller,
+                                                final int            access,
+                                                final boolean        isStatic,
+                                                final boolean        internal)
+   {
+      List<MatchMetrics> list = candidates(name, caller.length, access, isStatic, internal, false, null);
+      
+      // quick out if there are no possible matches
+      if (list.isEmpty())
+      {
+         return null;
+      }
+
+      final boolean[] ignore = new boolean[caller.length];
+      
+      Predicate<MatchMetrics> exactMatch = (mem) -> 
+      {
+         for (int i = 0; i < caller.length; i++)
+         {
+            if (!ignore[i] && !caller[i].equals(mem.data.signature[i]))
+            {
+               return false;
+            }
+         }
+          
+         return true;
+      };
+       
+      List<MatchMetrics> exact = list.stream().filter(exactMatch).collect(Collectors.toList());
+
+      Predicate<MatchMetrics> flexModeMatch = (mem) -> 
+      {
+         for (int i = 0; i < caller.length; i++)
+         {
+            if (!ignore[i])
+            {
+               if (caller[i].mode != null)
+               {
+                  if (!caller[i].equals(mem.data.signature[i]))
+                  {
+                     return false;
+                  }
+               }
+               else
+               {
+                  if (!caller[i].typeEquivalent(mem.data.signature[i]))
+                  {
+                     return false;
+                  }
+               }
+            }
+         }
+         
+         return true;
+      };
+      
+      MethodSearchResult result = null;
+      boolean       flex   = false;
+      
+      if (exact.isEmpty())
+      {
+         List<MatchMetrics> flexMode = list.stream().filter(flexModeMatch).collect(Collectors.toList());
+         
+         if (flexMode.size() == 1)
+         {
+            result = new MethodSearchResult(flexMode.get(0).data, null);
+            flex   = true;
+         }
+      }
+      else
+      {
+         if (exact.size() == 1)
+         {
+            result = new MethodSearchResult(exact.get(0).data, null);
+         }
+      }
+      
+      if (result != null)
+      {
+         // table-handle/dataset-handle matches are only valid when the only difference in signature is
+         // between a table/dataset and table-handle/dataset-handle
+
+         Iterator<MatchMetrics> iter = list.iterator();
+         
+         // calculate which parameters are both table-handles/dataset-handles and have conflicting
+         // signature (another signature that has a table/dataset in the same parameter position)
+         while (iter.hasNext())
+         {
+            MatchMetrics m = iter.next();
+            
+            for (int i = 0; i < caller.length; i++)
+            {
+               // quick iteration if we already know this parameter should be ignored 
+               if (ignore[i])
+                  continue;
+               
+               String type = m.data.signature[i].type;
+
+               if ("TABLE-HANDLE".equals(caller[i].type))
+               {
+                  if (type != null && type.startsWith("TEMP-TABLE"))
+                  {
+                     ignore[i] = true;
+                  }
+               }
+               else if ("DATASET-HANDLE".equals(caller[i].type))
+               {
+                  if (type != null && type.startsWith("DATA-SET "))
+                  {
+                     ignore[i] = true;
+                  }
+               }
+            }
+         }
+
+         // ignoring the conflicting parameters, can we still calculate find a unique match?
+         List<MatchMetrics> ignoreTH = list.stream()
+                                            .filter(flex ? flexModeMatch : exactMatch)
+                                            .collect(Collectors.toList());
+         if (ignoreTH.size() != 1)
+         {
+            result = null;
+         }
+      }
+      
+      return result;
+   }
+   
+   /**
+    * Remove any candidates from the list which do not match the caller's extent.  The following are
+    * possible matches:
+    * <p>
+    * <ul>
+    *    <li> Neither the caller nor the parameter definition have an extent specification.
+    *    <li> Both the caller and the parameter definition have an indeterminate extent.
+    *    <li> The caller has a fixed extent value and the parameter definition has the same fixed extent
+    *         value.
+    *    <li> The caller has a fixed extent value and the parameter definition has an indeterminate
+    *         extent.  This is a fuzzy match (all the above criteria are the same as exact matches). 
+    *
+    * @param    list
+    *           The list of candidates.
+    * @param    callerExtVal
+    *           Caller's extent value (-1 means indeterminate, 0 is scalar and any positive value is
+    *           the fixed extent).
+    * @param    idx
+    *           Parameter number being processed.
+    */
+   private void processExtentMatches(List<MatchMetrics> list, int callerExtVal, int idx)
+   {
+      Predicate<MatchMetrics> test = null;
+      Consumer<MatchMetrics>  mark = (m) -> m.extExact++;
+      
+      // no extent in caller
+      if (callerExtVal == 0)
+      {
+         // no extent in the parameter definition
+         test = (mem) -> mem.data.signature[idx].type.indexOf("[") == -1;
+         
+         // no marking needed here
+         mark = (m) -> {};
+      }
+      // indeterminate extent in caller
+      else if (callerExtVal == -1)
+      {
+         // indeterminate extent in the parameter definition
+         test = (mem) -> mem.data.signature[idx].type.indexOf("[") != -1 && 
+                         getExtent(mem.data.signature[idx].type) == -1;
+      }
+      // fixed extent in caller
+      else
+      {
+         test = (mem) -> 
+         {
+            int extIdx = mem.data.signature[idx].type.indexOf("[");
+            
+            if (extIdx != -1)
+            {
+               // the parameter definition is an extent
+               int parmExtVal = getExtent(mem.data.signature[idx].type);
+               
+               // fixed extents match exactly or the parm is indeterminate
+               return callerExtVal == parmExtVal || parmExtVal == -1;
+            }
+            else
+            {
+               // the parameter definition is NOT an extent
+               return false;
+            }
+         };
+
+         // this will only be used for where we already know extIdx != -1 above which means it is an
+         // extent at the parameter definition (it may be either fixed or indeterminate) 
+         mark = (mem) -> 
+         {
+            // the parameter definition is an extent
+            int parmExtVal = getExtent(mem.data.signature[idx].type);
+            
+            if (callerExtVal == parmExtVal)
+            {
+               // both are fixed extents match exactly
+               mem.extExact++;
+            }
+            else if (parmExtVal == -1) 
+            {
+               // or the parm is indeterminate
+               mem.extCvt++;
+            }
+         };
+      }
+      
+      list.removeIf(test.negate());
+      list.stream().forEach(mark);
    }
    
    /**
@@ -3296,6 +3576,87 @@
    }
    
    /**
+    * Check if there is only 1 possible match for the given predicate, if so then remove all candidates
+    * from the list except for that one possible match.
+    * 
+    * @param    list
+    *           The list to edit.
+    * @param    test
+    *           The predicate to test.
+    * @param    idx
+    *           The parameter index for error messages.
+    * @param    callerType
+    *           The caller type for error messages.
+    * @param    error
+    *           A location to store an error message for the caller.
+    */
+   private boolean allowIfOnlyOne(List<MatchMetrics>      list, 
+                                  Predicate<MatchMetrics> test,
+                                  int                      idx, 
+                                  String                   callerType,
+                                  String[]                 error)
+   {
+      boolean result = false;
+      
+      List<MatchMetrics> matches = list.stream().filter(test).collect(Collectors.toList());
+
+      int num = matches.size();
+
+      if (num == 1)
+      {
+         result = true;
+         matches.stream().forEach((m) -> m.cvt++);
+         list.removeIf(test.negate());
+      }
+      else if (num > 1)
+      {
+         error[0] = String.format("Ambiguous matches (%d) for parameter %d of type %s.",
+                               num,
+                               idx, 
+                               callerType);
+      }
+      else
+      {
+         error[0] = String.format("No possible matches for parameter %d of type %s.", idx, callerType);
+      }
+      
+      if (!result)
+      {
+         list.clear();
+      }
+      
+      return result;
+   }
+   
+   /**
+    * Remove any non-exact matches from the given list.
+    * 
+    * @param    list
+    *           The list to edit.
+    * @param    exactMatch
+    *           The test for an exact match.
+    *           
+    * @return   {@code true} if edits were made.
+    */
+   private boolean processExactMatches(List<MatchMetrics> list, Predicate<MatchMetrics> exactMatch)
+   {
+      // calculate the exact TYPE matches
+      List<MatchMetrics> exacts = list.stream().filter(exactMatch).collect(Collectors.toList());
+      
+      if (!exacts.isEmpty())
+      {
+         exacts.stream().forEach((m) -> m.exact++);
+         
+         // there is at least 1 exact match, remove everything else
+         list.removeIf(exactMatch.negate());
+         
+         return true;
+      }
+
+      return false;
+   }
+   
+   /**
     * Find the named method based on a fuzzy signature match. This method will search up the
     * parent hierarchy (recursively) if no fuzzy match is found in the current class.
     *
